commit 846f5913ffbacb7f9556050b57a49716ae9e8b5e
Author: Olga Brani <olgabrani@grnet.gr>
Date:   Tue Aug 27 10:59:11 2013 +0300

    new ui: Drag & drop functionality with styles

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
index 2c4abbc..91110fb 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/stylesheets/app.css
@@ -7684,88 +7684,89 @@ body.with-overlay {
   clear: left;
   padding: 10px 20px;
   border: 1px solid transparent;
+  text-align: left;
 }
-/* line 833, ../sass/app.scss */
+/* line 834, ../sass/app.scss */
 .storage .files li .name-col {
   float: left;
   width: 35%;
   padding-left: 50px;
 }
-/* line 837, ../sass/app.scss */
+/* line 838, ../sass/app.scss */
 .storage .files li .name-col.folder {
   background: url(../images/icon-folder.png) no-repeat left center;
 }
-/* line 838, ../sass/app.scss */
+/* line 839, ../sass/app.scss */
 .storage .files li .name-col.txt {
   background: url(../images/icon-txt.png) no-repeat left center;
 }
-/* line 839, ../sass/app.scss */
+/* line 840, ../sass/app.scss */
 .storage .files li .name-col.pdf {
   background: url(../images/icon-pdf.png) no-repeat left center;
 }
-/* line 841, ../sass/app.scss */
+/* line 842, ../sass/app.scss */
 .storage .files li .size-col {
   float: left;
   width: 10%;
 }
-/* line 845, ../sass/app.scss */
+/* line 846, ../sass/app.scss */
 .storage .files li .date-col {
   float: left;
   width: 20%;
 }
-/* line 849, ../sass/app.scss */
+/* line 850, ../sass/app.scss */
 .storage .files li .actions-col {
   float: left;
   width: 30%;
   visibility: hidden;
 }
-/* line 854, ../sass/app.scss */
+/* line 855, ../sass/app.scss */
 .storage .files li .actions-col a {
   color: #ff7bac;
   margin-right: 10px;
 }
-/* line 857, ../sass/app.scss */
+/* line 858, ../sass/app.scss */
 .storage .files li .actions-col a:hover {
   color: #919194;
 }
-/* line 861, ../sass/app.scss */
+/* line 862, ../sass/app.scss */
 .storage .files li:hover {
   border-color: #ff7bac;
 }
-/* line 863, ../sass/app.scss */
+/* line 864, ../sass/app.scss */
 .storage .files li:hover .actions-col {
   visibility: visible;
 }
-/* line 865, ../sass/app.scss */
+/* line 866, ../sass/app.scss */
 .storage .files li.titles {
   color: #919194;
 }
-/* line 867, ../sass/app.scss */
+/* line 868, ../sass/app.scss */
 .storage .files li.titles .name-col {
   padding-left: 0;
 }
-/* line 868, ../sass/app.scss */
+/* line 869, ../sass/app.scss */
 .storage .files li.titles:hover {
   border-color: transparent;
 }
-/* line 875, ../sass/app.scss */
+/* line 876, ../sass/app.scss */
 .storage .breadcrumbs li:first-child {
   font-weight: bold;
 }
-/* line 877, ../sass/app.scss */
+/* line 878, ../sass/app.scss */
 .storage .breadcrumbs li:first-child a {
   color: #333333;
 }
-/* line 879, ../sass/app.scss */
+/* line 880, ../sass/app.scss */
 .storage .breadcrumbs li:first-child a:hover {
   color: #ff7bac;
 }
-/* line 884, ../sass/app.scss */
+/* line 885, ../sass/app.scss */
 .storage .breadcrumbs a:hover {
   color: #ff7bac;
 }
 
-/* line 890, ../sass/app.scss */
+/* line 891, ../sass/app.scss */
 .progress-bar {
   position: fixed;
   bottom: 0;
@@ -7776,38 +7777,38 @@ body.with-overlay {
   padding: 20px 0 20px 310px;
   color: #919194;
 }
-/* line 899, ../sass/app.scss */
+/* line 900, ../sass/app.scss */
 .progress-bar span.counter {
   display: inline-block;
   margin-right: 20px;
   float: left;
 }
-/* line 904, ../sass/app.scss */
+/* line 905, ../sass/app.scss */
 .progress-bar a:hover {
   color: #ff7bac;
 }
-/* line 907, ../sass/app.scss */
+/* line 908, ../sass/app.scss */
 .progress-bar div.progress-wrap {
   display: inline-block;
   float: left;
   width: 40%;
   margin-right: 60px;
 }
-/* line 912, ../sass/app.scss */
+/* line 913, ../sass/app.scss */
 .progress-bar div.progress-wrap .progress {
   position: relative;
   top: 2px;
 }
-/* line 917, ../sass/app.scss */
+/* line 918, ../sass/app.scss */
 .progress-bar span.more {
   display: inline-block;
 }
 
-/* line 922, ../sass/app.scss */
+/* line 923, ../sass/app.scss */
 .overlay-wrapper {
   position: relative;
 }
-/* line 925, ../sass/app.scss */
+/* line 926, ../sass/app.scss */
 .overlay-wrapper .overlay-area {
   display: none;
   position: absolute;
@@ -7819,7 +7820,7 @@ body.with-overlay {
   background: #ff7bac;
   z-index: 20;
 }
-/* line 936, ../sass/app.scss */
+/* line 937, ../sass/app.scss */
 .overlay-wrapper .close {
   position: absolute;
   right: 2.5em;
@@ -7831,14 +7832,14 @@ body.with-overlay {
   text-indent: -2000px;
   overflow: hidden;
 }
-/* line 942, ../sass/app.scss */
+/* line 943, ../sass/app.scss */
 .overlay-wrapper .overlay-div {
   display: none;
   z-index: 100;
   position: relative;
 }
 
-/* line 949, ../sass/app.scss */
+/* line 950, ../sass/app.scss */
 .upload-widget {
   padding: 45px 0;
   width: 80%;
@@ -7846,23 +7847,28 @@ body.with-overlay {
   margin: 50px auto;
   text-align: center;
 }
-/* line 955, ../sass/app.scss */
+/* line 956, ../sass/app.scss */
 .upload-widget h2, .upload-widget a {
   color: #fff;
 }
-/* line 959, ../sass/app.scss */
+/* line 960, ../sass/app.scss */
 .upload-widget .btns a {
   margin: 0 10px;
 }
-/* line 964, ../sass/app.scss */
+/* line 965, ../sass/app.scss */
 .upload-widget .breadcrumbs {
   display: inline-block;
 }
-/* line 965, ../sass/app.scss */
+/* line 966, ../sass/app.scss */
 .upload-widget .breadcrumbs *, .upload-widget .breadcrumbs > *:before, .upload-widget .breadcrumbs li a:first-child, .upload-widget .breadcrumbs a:hover, .upload-widget .breadcrumbs li a:first-child:hover {
   color: #fff;
 }
-/* line 968, ../sass/app.scss */
+/* line 969, ../sass/app.scss */
 .upload-widget .breadcrumbs a:hover {
   text-decoration: underline;
 }
+
+/* line 978, ../sass/app.scss */
+.dz-success-mark, .dz-error-mark, .dz-error-message {
+  display: none;
+}